import os

def dia_to_schema(flow):
    if raw_input(
        'This will overwrite any existing SQL. Are you sure you '
        'want to do this? (y/N) '
    ).lower() == 'y':
        cmd = "%s -t %s -o %s %s" % (
            flow.config.option_group['schema']['tedia'],
            flow.config.option_group['schema']['type'],
            os.path.join(flow.config.app.app_dir, flow.config.option_group['schema']['sql_file']),
            os.path.join(flow.config.app.app_dir, flow.config.option_group['schema']['dia_file']),
        )
        print cmd
        os.system(cmd)
    else:
        print "Aborted"

def create_tables(flow):
    if raw_input(
        'This will try to create all the instance data structures. Are you sure you '
        'want to do this? (y/N) '
    ).lower() == 'y':
        flow.provider.start('database')
        filename = os.path.join(
            flow.config.app.app_dir, 
            flow.config.option_group['schema']['sql_file']
        )
        create_sql = []
        fp = open(filename, 'r')
        for line in fp:
            if line and not (line.startswith('drop')):
                create_sql.append(line)
        fp.close()
        connection = flow.database.connect()
        cursor = connection.cursor()
        sql = '\n'.join(create_sql)
        if not sql:
            print "No create statements found in %r"%(filename)
        else:
            cursor.execute('\n'.join(create_sql))
        cursor.close()
        flow.provider.stop('database')
        print "Success"
    else:
        print "Aborted"

def drop_tables(flow):
    if raw_input(
        'WARNING: This will remove all data from the existing instance. '
        'Are you sure you want to do this? (y/N) '
    ).lower() == 'y':
        flow.provider.start('database')
        filename = os.path.join(
            flow.config.app.app_dir, 
            flow.config.option_group['schema']['sql_file']
        )
        drop_sql = []
        drop_unique_index = []
        fp = open(filename, 'r')
        for line in fp:
            if line and line.startswith('drop'):
                if 'drop index ' in line:
                    drop_unique_index.append(line)
                else:
                    drop_sql.append(line)
        fp.close()
        connection = flow.database.connect()
        cursor = connection.cursor()
        sql = '\n'.join(drop_sql)
        if not sql:
            print "No table drop statements found in %r"%(filename)
        else:
            cursor.execute('\n'.join(drop_sql))
        cursor.close()
        flow.provider.stop('database')
        print "Success"
    else:
        print "Aborted"

