from bn import AttributeDict
from pkg_resources import iter_entry_points

available_plugins = {}
insert_record = {}
update_config = {}
engine_name = {}
driver_name = {}
param_style = {}
plugins_loaded = False

def load_available_plugins():
    dist_plugins = {}
    for ep in iter_entry_points(
        group='database.engine',
        # Use None to get all entry point names
        name=None,
    ):
        if not dist_plugins.has_key(ep.dist):
            dist_plugins[ep.dist] = {}
        dist_plugins[ep.dist][ep.name] = ep
    for k, v in dist_plugins.items():
        available_plugins[v['plugin_name'].load()] = {
            'insert_record': v['insert_record'],
            'engine_name': v['engine_name'],
            'driver_name': v['driver_name'],
            'update_config': v['update_config'],
            'param_style': v['param_style'],
        }
    plugins_loaded = True
 
